/*
 * clk.c
 *
 * written by SASANO Takayoshi
 * --- public domain, no warranty.
 * --- thanks to Paul Hsieh <http://www.azillionmonkeys.com/qed/mhz.html>
 */

#include <bstdio.h>
#include <errcode.h>
#include <btron/btron.h>

Inline	void	rdtsc(UW *eax, UW *edx)
{
	Asm("rdtsc" : "=a"(*eax), "=d"(*edx));

	return;
}


EXPORT	ERR	main(W argc, TC *argv[])
{
	long long	before, after;	/* 64bit */
	double	clock;
	UW	eax0, edx0, eax1, edx1;
	STIME	t0, t1;

	/* Ready? */
	get_tim(&t0, NULL);
	do {
		get_tim(&t1, NULL);
	} while (t1 == t0);

	/* Go! */
	rdtsc(&eax0, &edx0);
	do {
		get_tim(&t0, NULL);
	} while(t0 == t1);
	rdtsc(&eax1, &edx1);

	/* Finish!! */
	before = ((long long)edx0 << 32) | eax0;
	after  = ((long long)edx1 << 32) | eax1;
	clock  = (double)(after - before) / 1000000;

	printf("%.3fMHz\n", clock);

	return ER_OK;
}
